"use strict";
/*
 * MIT License
 *
 * Copyright (c) 2019 Choko (choko@curioswitch.org)
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
Object.defineProperty(exports, "__esModule", { value: true });
const resolve_1 = require("../../resolve");
class FallbackResolverPlugin {
    apply(resolver) {
        const tapable = resolver;
        const target = tapable.ensureHook('resolve');
        tapable
            .ensureHook('described-resolve')
            .tapAsync('FallbackResolverPlugin', (request, resolveContext, callback) => {
            const rewritten = resolve_1.rewriteResolveRequest(request.request);
            if (rewritten === request.request) {
                return callback();
            }
            // Cast to any since types don't match webpack definition
            return resolver.doResolve(target, Object.assign(Object.assign({}, request), { request: rewritten }), `rewriting ${request.request} to ${rewritten}`, resolveContext, callback);
        });
    }
}
exports.default = FallbackResolverPlugin;
//# sourceMappingURL=index.js.map